      PROGRAM BELL99
      INCLUDE 'BELL99.INC'


      COMMON /RANDEP/NPRF,INDPRF,RANGEPRF(NMAXPRF)
      COMMON /REV1/BOTT_ANG(201,2),SURF_ANG(201,2),BOTT_IND,SURF_IND
      INTEGER BOTT_IND,SURF_IND

      INTEGER  PRTFIL,RAYFIL,ENVFIL
      INTEGER  I,NSD,IZ,IBEAM,IR

      REAL(4) IT, TA(2)

      REAL P( 201, 201 )

      REAL U(MAXNRZ)

      COMPLEX EPS , PICKEPS
      CHARACTER TITLE*80, TOPOPT*3, BOTBC*1, RUNTYP*2, BEAMTYP*2

      DIMENSION SD( MAXNSD ), RD( MAXNRD ), R( MAXNR )
     +    ,ALPHA( MAXNBEAMS )
      DIMENSION ZOOMX(200), ZOOMY(200)
      DIMENSION XRAN(MAXN),YRAN(MAXN)
      DIMENSION TZ (MAXPRF), TC(MAXPRF)
      DIMENSION CELL_OF_MAT(201)
      DIMENSION PLOSSTMP(201)
      INTEGER CELL_OF_MAT

      ENVFIL = 15
      PRTFIL = 16
      RAYFIL = 21
      NBCOUNT=0
      MAXNBR=0

      OPEN(123,FILE='RFAC.DAT',FORM='FORMATTED',STATUS='UNKNOWN')
	OPEN(15,FILE='BELL.ENV',FORM='FORMATTED',STATUS='UNKNOWN')
      OPEN(93,FILE='PRF.PLT',FORM='FORMATTED',STATUS='UNKNOWN')
      OPEN(94,FILE='TAILPRF.PLP',FORM='FORMATTED',STATUS='UNKNOWN')
      OPEN(95,FILE='RAY.PLT',FORM='FORMATTED',STATUS='UNKNOWN')
      OPEN(96,FILE='TAILRAY.PLP',FORM='FORMATTED',STATUS='UNKNOWN')
	OPEN(16,FILE='BELL.PRT',FORM='FORMATTED',STATUS='UNKNOWN')

      CALL READIN( TITLE, FREQ, ALPHA, NBEAMS
     *,DELTAS, ZBOX, RBOX, EPMULT, RLOOP
     *,SD, NSD, RD, NRD,R,NR,TOPOPT,BOTBC,RUNTYP,BEAMTYP
     *,DEPTH, NMAXB,TCOEFF,TMIN)

      CALL PBOUND(TOPOPT,BOTBC,PRTFIL,BTMPRV)

      IR = 0
      NB = NMAXB
      ZOOMX(1) = BOTTOM_RANGE(1)
      ZOOMY(1) = BOTTOM(1)


      DO IZ = 2, 200
	  RANGE = RBOX * (IZ-1) / 200.
	  ZOOMX(IZ) = RANGE
	  IZZ = 1
	  DO WHILE (RANGE .GT. BOTTOM_RANGE(IZZ))
	    IZZ = IZZ + 1
	  ENDDO
	  DX = BOTTOM_RANGE(IZZ)-BOTTOM_RANGE(IZZ-1)
	  IF(BOTTOM(IZZ) .EQ. BOTTOM(IZZ-1)) THEN
	    ZOOMY(IZ) = BOTTOM(IZZ)
	  ELSE
	    ZOOMY(IZ) = BOTTOM(IZZ-1)-(BOTTOM(IZZ-1)-BOTTOM(IZZ))*
     *    ((RANGE-BOTTOM_RANGE(IZZ-1))/DX)
	  ENDIF
	  IF (ZOOMY(IZ) .GT. RMAXD) RMAXD = ZOOMY(IZ)
      ENDDO


      DO IZ = 1, 200,2
	ZOOMY(IZ) = -ZOOMY(IZ)
      ENDDO


      IF ( NR .GE. 2 ) THEN
	  DELTAR = R( NR ) - R( NR - 1 )
      ELSE
	  DELTAR = 0.0
	  CALL ERROUT(PRTFIL,'F','BELLHOP','NUMBER OF RANGES ARE NOT 
     &      SUFFICIENT')
      ENDIF

      INDPRF=1

      IF ( NBEAMS .NE. 1 ) THEN
	  DALPHA = ( ALPHA( NBEAMS ) - ALPHA( 1 ) ) / ( NBEAMS - 1 )
      ELSE
	  DALPHA = 0.0
	CALL ERROUT(PRTFIL,'F','BELLHOP','NUMBER OF BEAMS ARE NOT 
     &      SUFFICENT')
      ENDIF

      NSD    = 1
      IREC   = 5

      DO II = 1,NR
	BOTT_ANG(II,1)=0
	BOTT_ANG(II,2)=0
	SURF_ANG(II,1)=0
	SURF_ANG(II,2)=0
      ENDDO

      DO 9000 IS = 1, NSD
	RS = 0.0
	ZS = SD( IS )
								   
	CALL CCUBIC( RS,ZS,C,CR,CZ,CRR,CRZ,CZZ,'TABB',TZ,TC)
	IF (PRTFIL .EQ. 1) THEN
	  WRITE(PRTFIL,*)' SOURCE DEPTH AND C ',ZS,C 
	ENDIF
	OMEGA = 2.0 * PI * FREQ

	DALPHAOPT = SQRT( C / ( 6.0 * FREQ * R( NR ) ) )

	EPS = PICKEPS( BEAMTYP(1:1), OMEGA, C, DALPHA, RLOOP, EPMULT )

	NSECTION=0

	DO 8000 IBEAM = 1, NBEAMS
	    ALPHAGD = ALPHA(IBEAM)/DEGRAD
	    NBB = 0

	    DIV=1.0
	    FLAG_PERIOD = 0
	    ANGLE_PERIOD = 30.0*DEGRAD
	    PERIOD = .5*DEGRAD
	    DIFF_ANGLE = ABS( ABS(ALPHA(IBEAM)) - ABS(CRTANG(INDPRF)))
	    IF(DIFF_ANGLE .LT. PERIOD .AND. SD(1) .LT. 
     &          D_DUCTC(INDPRF))THEN
	      DIV = 1.0
	      FLAG_PERIOD = 1
	    END IF




	    CALL TRACE( DELTAS*DIV, RS, ZS, ALPHA( IBEAM ), OMEGA
     *      ,BEAMTYP,TOPOPT,DEPTH,ZBOX,RBOX,BOTBC,NMAXB
     *      ,NBB,FLAG_PERIOD,TZ,TC)
	    IF ( RUNTYP(1:1) .EQ. 'I' )
     &          CALL INFLUG( OMEGA,R, NR, DELTAR, ZS,
     &          ALPHA( IBEAM ), U, RD, NRD, DEPTH,
     &          RUNTYP, TOPOPT, RADMAX, DALPHA, NMAXB,
     &          BTMPRV, FREQ, IR,ZBOX)



	    IR = MAX( NSTEPS / 1000, 1 )
	    IP = 0
	    DO I=1,NSTEPS, IR
	      IP = IP + 1
	      XRAN(IP) = RV(I)
	      YRAN(IP) = ZV(I)
	    ENDDO

	    nfl=95
	    CALL FIP(XRAN,YRAN,IP,nfl)

8000   CONTINUE      ! Next beam

8192  FORMAT (A5,I6)
8193  FORMAT (A80)  


	IF ( RUNTYP(1:1) .EQ. 'I' ) THEN
	  CONST = 1.0
	  CALL SCALE( CONST, R, U, NRD, NR, RUNTYP, TOPOPT, FREQ )
	  CALL WRTFLD( SD( IS ), RD, NRD, U, NR, IREC, R,RBOX,ZBOX,
     &           FLAG_FILTER, DEPTH)
	ENDIF
	


9000  CONTINUE    ! Next source depth

10000 CONTINUE


1120  FORMAT (6(1X,E12.5))
	IF ((FLAG_REVER .EQ. 1) .AND. (RUNTYP(1:1) .EQ. 'I')) THEN
	  IF (NRD.GT.1) THEN
	      OPEN(23,FILE='MAT.MAT',FORM='FORMATTED',STATUS='UNKNOWN')
	    DO I=1,NRD
	      READ(23,1120) (P(I,K),K=1,NR)
	    ENDDO
	    CLOSE(23)
	  
	    DO ICI = 1, NR
	      IRI=1
	      DO WHILE ((P(IRI,ICI) .LT. 800) .AND. (IRI .LT. 101))
		IRI=IRI+1
	      ENDDO
	      CELL_OF_MAT(ICI)=IRI-1
	    ENDDO
	    PLOSSTMP(1) = P(1,1)
	    PLOSSTMP(2) = P(1,2)
	    DO II = 3, NR-2
	      PLOSSTMP( II ) = (P(1,II-2)+P(1,II-1)+P(1,II)+P(1,II+1)
     +            +P(1,II+2))/5.
	    ENDDO
	    PLOSSTMP(NR-1) = P(1,NR-1)
	    PLOSSTMP(NR) = P(1,NR)
	  
	      WRITE(123,1120) (PLOSSTMP(K),K=1,NR)
	      WRITE(123,1120) (P(CELL_OF_MAT(K),K),K=1,NR)
	  ENDIF
	  
	  DO II = 1,NR
	    IF (BOTT_ANG(II,2) .GT. 0) THEN
	      BOTT_ANG(II,1)=BOTT_ANG(II,1) / BOTT_ANG(II,2)
	      BOTT_ANG(II,1)=BOTT_ANG(II,1) / DEGRAD
	    ENDIF
	  
	    IF (SURF_ANG(II,2) .GT. 0) THEN
	      SURF_ANG(II,1)=SURF_ANG(II,1) / SURF_ANG(II,2)
	      SURF_ANG(II,1)=SURF_ANG(II,1) / DEGRAD
	    ENDIF
	  
	  ENDDO
	  
	  
	  WRITE(123,1120) (SURF_ANG(K,1),K=1,NR)
	  WRITE(123,1120) (BOTT_ANG(K,1),K=1,NR)
	ENDIF

      CLOSE(123)
      CLOSE(93)
      CLOSE(94)
      CLOSE(95)
      CLOSE(96)


      IT = ETIME(TA)

	IF (PRTFIL .EQ. 1) THEN
        write(prtfil,*)'Program has used', IT, 'seconds of CPU time.'
        write(prtfil,*)'This includes',TA(1),'seconds of user time and', 
     &   TA(2), 'seconds of system time.'
	ENDIF


103   FORMAT(A40)
104   format(2x,f6.2,2x,i7,2x,f9.2)
    
      END
