      SUBROUTINE CMAX( ZV, CVS, MXSSP )

      INTEGER IMAX,JMAX

      PARAMETER ( HALF = 0.5, SIXTH = 1.0 / 6.0 )

      REAL DELTA

      DIMENSION  CVS(4, MXSSP), C(4), ZV(*)

      COMMON /S_DUCT/ D_DUCT, C_DUCT, IMAX

      IF (IMAX .LE. 1) RETURN 

      JMAX= IMAX-1

      C(1)= CVS(1, JMAX)
      C(2)= CVS(2, JMAX)
      C(3)= CVS(3, JMAX)
      C(4)= CVS(4, JMAX)

      DELTA= C(3)**2 - 2.0*C(2)*C(4)
      IF( DELTA .GT. 0.0 )   THEN
        DELTA= SQRT(DELTA)
      ELSE
        DELTA= 0.0
      END IF

      ROOTM= ( -C(3) - DELTA ) / C(4)
      ROOTP= ( -C(3) + DELTA ) / C(4)

      FXXM= C(3) + ROOTM*C(4)
      FXXP= C(3) + ROOTP*C(4)


      ZX= ROOTM
      FF= C(1) + ZX * ( C(2) +
     +ZX * ( HALF * C(3) + SIXTH * ZX * C(4) ) )
      ZX= ROOTP
      FF= C(1) + ZX * ( C(2) +
     +ZX * ( HALF * C(3) + SIXTH * ZX * C(4) ) )


      IF(FXXM .LT. 0.0)   THEN
        D_DUCT= ROOTM + ZV(JMAX)
      ELSE
        D_DUCT= ROOTP + ZV(JMAX)
      END IF


      ZX= D_DUCT - ZV(JMAX)
      C_DUCT= C(1) + ZX * ( C(2) +
     +ZX * ( HALF * C(3) + SIXTH * ZX * C(4) ) )

      RETURN
      END
