      SUBROUTINE INFLUG( OMEGA, R, NR, DELTAR, ZS, ALPHA, U,
     &   RD, NRD, DEPTH, RUNTYP, TOPOPT, RADMAX, DALPHA,
     &   NMAXB, BTMPRV, FREQ, IR, ZBOX)


      INCLUDE 'BELL99.INC'
      COMMON /RANDEP/NPRF,INDPRF,RANGEPRF(NMAXPRF)
      COMMON /REV1/BOTT_ANG(201,2),SURF_ANG(201,2),BOTT_IND,SURF_IND
      INTEGER BOTT_IND,SURF_IND




      REAL      QV( MAXN ), RD( NRD ), R( NR )
      REAL      U( NRD, NR ), CONST, CONTRI, CAUSTIC
      CHARACTER TOPOPT*3, RUNTYP*2
      INTEGER MIOINDICE,IPRFOLD
      REAL LDB, MAXDEPTH, MINDEPTH

      EQUIVALENCE ( QV, Q1V )

      RADMASSIMO = 0.0
      MINDEPTH = DEPTH
      MAXDEPTH   = 0.0
      
      IPRF=1
      IPRFOLD=1

      DO I = 3, NSTEPS
	MINDEPTH = MIN( MINDEPTH, ZV(I) )
	MAXDEPTH = MAX( MAXDEPTH, ZV(I) )
      ENDDO
      MINDEPTH = MINDEPTH - ZBOX/50.	
      MAXDEPTH = MAXDEPTH + ZBOX/50.

      DS = SQRT( 2.0 ) * SIN( OMEGA * ZS * ZETAV( 1 ) )
      Q0 = CV( 1 ) / DALPHA
      CAUSTIC = 1
      QOLD    = 1.0
      Q1METER = CV( 1 )
      RAT1    = SQRT( Q1METER / CV ( 1 ) * COS( ALPHA ) )
      IR=1
      IRIM = 1 
      IREV = 0
      LDB = 0.0
      MIOINDICE = 0
    
      RA = RV( IR )
      RIMBALZO = CONTREF(IRIM)

      DO 5000 I = 1, NSTEPS

		IREV = 0
		DO KKK=1,NPRF
			IF (RANGEPRF(KKK) .LE. RV(I)) IPRF=KKK
		ENDDO
		IF (IPRF .NE. IPRFOLD) THEN
			DS = SQRT( 2.0 ) * SIN( OMEGA * ZSNEW(IPRF) * ZETAV( I ) )
			Q0 = CV( I ) / DALPHA
			CAUSTIC = 1
			QOLD    = 1.0
			Q1METER = CV( I )
			RAT1    = SQRT( Q1METER / CV ( I ) * COS(RNALPHA(IPRF) ) )
		ENDIF


		IF (I .EQ. RIMBALZO .AND. IRIM .LT. NBR+1) THEN 
			IF (ZV(I) .LT. 0.5) THEN  !SURFACE
				IF (PROVINCE( IRIM ) .EQ. 0.0) THEN
					PERDITA = 0.0
				ELSE
					PERDITA = SURF_NEW(REFANGLE(IRIM),FREQ,
	&											PROVINCE(IRIM))
				ENDIF

				IF (ABS(REFANGLE(IRIM)) .LT. PI/4.0 ) THEN
					SURF_IND=IR
					SURF_ANG(SURF_IND,1)=SURF_ANG(SURF_IND,1)+
     &										  REFANGLE(IRIM)
					SURF_ANG(SURF_IND,2)=SURF_ANG(SURF_IND,2)+1
				ENDIF

				LDB = LDB + PERDITA
			ELSE
				INDEX_ANGLE = REFANGLE(IRIM)*57.295 !BOTTOM
				IF (BTMPRV .EQ. 0.0) THEN
					INDEX_ANGLE = REFANGLE(IRIM)*57.295 
					PERDITA = LOSS_TABLE(INDEX_ANGLE+1)
					IF ( INDEX_ANGLE .LT. CUTOFF_ANGLE ) PERDITA = 0.0
				ELSE
					PERDITA = BOTT_NEW(REFANGLE(IRIM),FREQ,
	&												PROVINCE(IRIM))

					IF ( INDEX_ANGLE .LT. CUTOFF_ANGLE ) PERDITA = 0.0
				ENDIF
				IF (ABS(REFANGLE(IRIM)) .LT. PI/4.0 ) THEN
					BOTT_IND=IR
					BOTT_ANG(BOTT_IND,1)=BOTT_ANG(BOTT_IND,1)
     &                                     +REFANGLE(IRIM)
					BOTT_ANG(BOTT_IND,2)=BOTT_ANG(BOTT_IND,2)+1
				ENDIF
				LDB = LDB + PERDITA
			ENDIF
			IRIM = IRIM + 1
			RIMBALZO = CONTREF(IRIM)
	    ENDIF

	    RB = RV( I )

1000    CONTINUE
	IF ( RB .NE. RA .AND. RB .GT. R( IR ) ) THEN

	    W = ( R( IR ) - RA ) / ( RB - RA )
	    Z     =     ZV(I-1) + W * (     ZV(I) -     ZV(I-1) )
	    C     =     CV(I-1) + W * (     CV(I) -     CV(I-1) )
	    Q     =     QV(I-1) + W * (     QV(I) -     QV(I-1) )
	    RHO   =   RHOV(I-1) + W * (   RHOV(I) -   RHOV(I-1) )
	    ZETA  =  ZETAV(I-1) + W * (  ZETAV(I) -  ZETAV(I-1) )
	    TAU   =   TAUV(I-1) + W * (   TAUV(I) -   TAUV(I-1) )

	    TR = RHO * C
	    A  = ABS( TR * Q0 / Q )
	    RADMAX = 1.0 / A
10	FORMAT(2X,F5.1,6(2X,E10.4))

	 OLDRADMAX=RADMAX

	  RADMAX = MIN( RADMAX, ZBOX/10. )
	  IF( ZSNEW(IPRF) .LT. D_DUCTC(IPRF) .AND. ABS(RNALPHA(IPRF))
     +        .LT. (CRTANG(IPRF)) ) THEN
	   RADMAX = MIN( RADMAX, D_DUCTC(IPRF)-ZV(I) )
	   RADMAX = MIN( RADMAX, 200. )
	  ENDIF
	  RADMAX = MIN( RADMAX, ABS(MAXDEPTH-ZV(I)) )



	  IPRFOLD=IPRF

	    IF ( Q .LT. 0.0 .AND. QOLD .GE. 0.0 .OR.
     &           Q .GT. 0.0 .AND. QOLD .LE. 0.0 )
     &                                   CAUSTIC = CI * CAUSTIC

	    CONST = RAT1 * SQRT( C / ABS( Q ) )




	  DO 9000 IRCVR = 1, NRD
	      DELTAZ =  RD( IRCVR ) - Z
	      ADZ    = ABS( DELTAZ )

	    IF ( ADZ .LT. RADMAX ) THEN
	      CONTRI = CONST ** 2 * A * ( OLDRADMAX - ADZ )

	      U( IRCVR, IR ) = U( IRCVR, IR ) + CONTRI*(
     &            10.0**(-LDB/10.0))

		  MIOINDICE = MIOINDICE + 1
	    ENDIF
 9000     CONTINUE      ! Next receiver depth




	    QOLD = Q
	    IR = IR + 1
	  ISTAM     = 0
	  IF ( IR .GT. NR ) THEN
	      TOTITERAZIONI = TOTITERAZIONI + MIOINDICE
	      RETURN
	  ENDIF
	  GOTO 1000     ! Next receiver range  IT DOES NOT REPEAT

	ENDIF
	RAPRIMA = RA
	RA = RB

 5000 CONTINUE      ! Next step along the ray

      RETURN
      END


      FUNCTION  SURF_NEW( ANG, FRQ ,SPEEDKNT)
      DATA  PI/3.14159265/
      FACTOR1 = 500.0/( 3.0 + 2.6*SPEEDKNT )
      FRQSPEED = 2.0E-5 * FRQ * SPEEDKNT**2
      FACTOR2 = 0.3 + 0.7/( 1.0 + 0.01*FRQSPEED**2 )
      T = FACTOR1 * ANG**2 / 4.0
      SINANG = SIN(ANG)
      SINRAT = 1.0
      IF( ANG.GT.0.0 )  SINRAT=SINANG/ANG
      V = SINANG - SINRAT*EXP(-T)/SQRT(FACTOR1*PI)
      V = MAX( V, SINANG/2.0 )
      V = MIN( V, 0.99 )
      SURF_NEW = FACTOR2 * SQRT(1.0-V)
      SURF_NEW = -20.*ALOG10(SURF_NEW)
      
      RETURN
      END

C
C
      FUNCTION  BOTT_NEW( ANG, FRQ, BPROV )
      DIMENSION  COEF(9,3), COEFF(3)
      DATA  COEF/
     1    -2.2435,        -3.4315,        -2.4910,
     1    -2.8377,        -2.4036,        -1.8320,
     1    -2.0000,        -2.0000,        -2.0000,
     2     7.2193,         6.0504,        50.7870,
     2   107.4525,      1178.9180,     62075.6226,
     2     0.0000,         0.0000,         0.0000,
     3     1.4960,         2.8420,        10.5260,
     3    15.6850,        82.4400,       896.6310,
     3 98715.7710,    729416.3700,   8886110.5200/
      DATA  REF0/0.0/
      IF( FRQ.LE.1000.0 )  THEN
	REF0 = +3.10902 + ANG*( -23.12956134 + ANG*( +16.34151456
     1                  + ANG*( -5.449747152 + ANG*( +0.969913578 ))))
      ENDIF

      IF( FRQ.LE.100.0 )THEN
	RFLDB = REF0
	BOTT_NEW = -RFLDB
	RETURN
      ENDIF

      IBP = MAX(BPROV,1.0)
      IBP = MIN(IBP,8)
      DO   JCOEF=1,3
	COEFF(JCOEF) = (IBP+1-BPROV)*COEF(IBP,JCOEF)
     *           + (BPROV-IBP)*COEF(IBP+1,JCOEF)
      ENDDO
CATT
      ARGLOG=(COEFF(2)*ANG + COEFF(3) )
	IF (ARGLOG .GT. 0.0)  THEN
		RFLPRV = COEFF(1) * LOG( ARGLOG)
	ELSE
		PRINT *,'error',COEFF(2),COEFF(3),ANG
		RFLPRV = -1.0e38
      ENDIF
CATT

	RFLDB = RFLPRV
      IF( FRQ.LT.1000.0 )THEN
	FRQFCT=LOG10(FRQ/100.0)
	RFLDB = REF0 + FRQFCT*(RFLPRV-REF0)
      ENDIF
      BOTT_NEW = -RFLDB
      RETURN
      END


