      SUBROUTINE READIN( TITLE, FREQ, ALPHA, NBEAMS,
     *   DELTAS, ZBOX, RBOX, EPMULT, RLOOP,
     *   SD, NSD,RD,NRD,R,NR,SSPOPT,BOTBC,RUNTYP,BEAMTYP, 
     *   DEPTH, NMAXB, TCOEFF, TMIN)

      INTEGER ENVFIL, NR , NBEAMS

      INTEGER PRTFIL
      PARAMETER (ENVFIL=15,PRTFIL=16)
      
      DIMENSION ALPHA(*), SD(*),R(*)
      INCLUDE 'BELL99.INC'

      COMMON /RANDEP/NPRF,INDPRF,RANGEPRF(NMAXPRF)

      DIMENSION TZ(MAXPRF),TC(MAXPRF),XRAN(MAXPRF),YRAN(MAXPRF)


      CHARACTER TITLE*80,SSPOPT*3,BOTBC*1,TOPOPT*1,RUNTYP*2,BEAMTYP*2

      READ(  ENVFIL, 100 ) TITLE(16:56)
      READ(  ENVFIL, * ) FREQ

      READ(  ENVFIL, * ) PRTLAG

      TITLE(1:15) = ' ---BELLHOP--- '


      READ(  ENVFIL, * )SSPOPT
      TOPOPT = SSPOPT(2:2)
      READ(  ENVFIL, * ) NMAXB, RNPRF, DEPTH
      NPRF=RNPRF

      NPI2=0
      INDPRF=1
      RANGEPRF(1) =0.0

95    NPI2 = NPI2 + 1
      READ(ENVFIL,*)TZ(NPI2),TC(NPI2)
      YRAN(NPI2) = TZ(NPI2)
      XRAN(NPI2) = TC(NPI2)
      IF (ABS(TZ(NPI2)-DEPTH).GT..01) GOTO 95

      CALL FIP(XRAN,YRAN,NPI2,93)

      IF(NPI2.GT.MAXPRF) THEN
        CALL ERROUT( PRTFIL, 'F', 'READIN',
     *    'Number of Sound speed points exceeds limit' )
      ENDIF

      CALL CCUBIC( R, DEPTH,C,CR,CZ,CRR,CRZ,CZZ,'INIT',TZ,TC)


      READ( ENVFIL, * ) BOTBC, RFLAG_REVER
      FLAG_REVER=RFLAG_REVER

      ZMIN = 0.0
      ZMAX = DEPTH

      CALL SDRD(ENVFIL,PRTFIL,ZMIN,ZMAX,MAXNSD,NSD,SD,MAXNRD,NRD,RD)

      CALL RANGES( ENVFIL, PRTFIL, MAXNR, NR, R )

      CALL LAYER ( PRTFIL,R(NR))

      READ(  ENVFIL, * ) RUNTYP(1:2)

      IF ( RUNTYP(1:1) .NE. 'R' ) THEN
         NMAXB = 51
      ENDIF

      NBEAMS = 0
      ALPHA( 3 ) = -999.9
      READ( ENVFIL,*)NBEAMS,( ALPHA(IBEAM), IBEAM=1,NBEAMS )

      IF ( NBEAMS .GT. MAXNBEAMS ) THEN
        CALL ERROUT( PRTFIL, 'F', 'READIN', 'Too many  beams'  )
      ENDIF

      CRTANG(INDPRF) = 0.0
      ZS=SD(1)
      RS=0

      CALL CCUBIC( RV(1),ZS,CZS,CR,CZ,CRR,CRZ,CZZ,'TABB',TZ,TC)


      IF( IMAXC(INDPRF) .GT. 0 .AND. ZS .LT. D_DUCTC(INDPRF)) THEN
        TTT=CZS/C_DUCTC(INDPRF)
        IF (TTT .GT. 1.0) TTT=1.0
        CRTANG(INDPRF)= ACOS(TTT) 
      ENDIF

	IF (PRTFIL .EQ. 1) THEN
        WRITE(PRTFIL,*)' CRT ANG AT FIRST PROFILE : ',
     +    CRTANG(INDPRF)/DEGRAD
	ENDIF  

      DELTA_SPLITTING=.125
      CALL SUBALPHA( ALPHA, NBEAMS, CRTANG(INDPRF),DELTA_SPLITTING)
      CALL SORT(   ALPHA, NBEAMS )

	IF (PRTFLAG .EQ. 1 ) THEN
        IF ( NBEAMS .GE. 1 ) WRITE( PRTFIL,700)
     *   ( ALPHA( IBEAM )/DEGRAD, IBEAM = 1, NBEAMS )  !PRINT IN DEG
	ENDIF

      READ(  ENVFIL, * ) DELTAS, ZBOX, RBOX 

      RBOX = 1000.0 * RBOX


      IF ( DELTAS .EQ. 0.0 ) THEN
        DELTAS =INT(MIN(DEPTH/60.,10.))
      ENDIF

      IF (IMAXC(1) .GT. 0) THEN
	  DELTASD = INT(MIN(DELTASD/10.0,D_DUCTC(INDPRF)/10.0))
	  DELTASD=INT(MAX(DELTASD,2.0))
	ENDIF


	IF (PRTFIL .EQ. 1) THEN
        WRITE(PRTFIL,*)' DELTAS =  ',DELTAS,', DELTASD = ',DELTASD
	ENDIF


    
      BEAMTYP(1:2) = 'MS'
	RLOOP  = 1.0
	EPMULT = 1.0

      NPI2 = 0
      DO WHILE (NPRF .GT. INDPRF) 
        NPI2 = 0
        INDPRF=INDPRF+1
        READ(ENVFIL,*)RRRR,DEPTHTMP
        RANGEPRF(INDPRF)=RRRR*1000.0
96      NPI2 = NPI2 + 1
        READ(ENVFIL,*)TZ(NPI2),TC(NPI2)
        YRAN(NPI2) = TZ(NPI2)
        XRAN(NPI2) = TC(NPI2)
        IF (ABS(TZ(NPI2)-DEPTHTMP).GT..01) GOTO 96
        CALL FIP(XRAN,YRAN,NPI2,93)
        CALL CCUBIC( R, DEPTHTMP,C,CR,CZ,CRR,CRZ,CZZ,'INIT',TZ,TC)

      ENDDO
      CLOSE( ENVFIL )

100   FORMAT(A40)
200   FORMAT(' Operator''s level = ',I2)
210   FORMAT(' Maximum number of bottom bounces = ',I2)
205   FORMAT(' Frequency = ',F8.2,' [Hz] ')
220   FORMAT(' Range''s flag [I=0] [D=1] = ',I2)
230   FORMAT(' Source''s depth = ', F7.2,' [m]')
240   FORMAT(' Angles'' number = ',I2)

700   format (8(2x,f8.2))
991   FORMAT(F10.2)

9999  CONTINUE
      RETURN
      END
