      SUBROUTINE REFLECT(RUNNING_DEPTH, I, OMEGA, BEAMTYP, TOPOPT, BC,
     &       TZ,TC)

      CHARACTER TOPOPT*3, BEAMTYP*2, BC*1
      REAL RAY_TG

      INCLUDE 'BELL99.INC'
      DIMENSION TZ(*),TC(*)

      CALL CCUBIC(RV(I),ZV(I),C,CR,CZ,CRR,CRZ,CZZ,'TABB',TZ,TC)

      IF ( RUNNING_DEPTH .EQ. 0.0 ) THEN
        RAY_TG = 0.0
        IF ( ZV( I ) .NE. ZV( I+1 ) ) THEN
          RAY_TG = (RV( I+1 ) - RV( I ) ) / ( ZV( I ) - ZV( I+1 ) )
        ENDIF 
c
c        ZV(    I+1 ) =     1.E-6
c        RV(    I+1 ) =     RV( I ) + RAY_TG * ZV( I )
c
        ZETAV( I+1 ) =  -  ZETAV( I )
        RHOV(  I+1 ) =     RHOV(  I )
        CALL CCUBIC(RV(I+1),ZV(I+1),C,CR,CZ,CRR,CRZ,CZZ,'TABB',TZ,TC)
      ELSE
        RAY_TG = (ZV( I+1 ) - ZV( I ) ) / ( RV( I+1 ) - RV( I ) )
        RV( I+1 ) = ( -BOTTOM(BOTTOM_LAYER) + ZV( I ) - RV( I )*
     +      RAY_TG +BOTTOM_ANGLE( BOTTOM_LAYER ) * 
     +      BOTTOM_RANGE( BOTTOM_LAYER ) ) /( -RAY_TG + 
     +      BOTTOM_ANGLE( BOTTOM_LAYER ) )

        ZV( I+1 ) = ZV(I)+(RV(I+1)-RV(I))*RAY_TG

        CALL CCUBIC(RV(I+1),ZV(I+1),C,CR,CZ,CRR,CRZ,CZZ,'TABB',TZ,TC)

	  ALPHA_RAY=ATAN(RAY_TG)
	  ALPHA_BOTTOM=-ATAN(BOTTOM_ANGLE(BOTTOM_LAYER))
	  ALPHA_OUT=ALPHA_RAY+2*ALPHA_BOTTOM

        RHOV(  I+1 ) = COS(ALPHA_OUT)/C
        ZETAV( I+1 ) = SIN(ALPHA_OUT)/C

        IF (RAY_TG .GT. 0.0) THEN
          ZETAV(I+1)   = - ZETAV( I+1 )
        ENDIF

      ENDIF


      CV( I ) = C

	RN =1.
	IF (C .NE. 0.0 .AND. CZ .NE. 0 .AND. ZETAV(I+1) .NE. 0.0) THEN
      RN = -2.0 * RHOV( I + 1 )**2 / ZETAV( I + 1 ) * CZ / C
	ENDIF

      IF ( BEAMTYP(2:2) .EQ. 'D' ) RN = 2.0 * RN
      IF ( BEAMTYP(2:2) .EQ. 'Z' ) RN = 0.0

      P1V( I + 1 ) = P1V( I ) + Q1V( I ) * RN
      Q1V( I + 1 ) = Q1V( I )
      P2V( I + 1 ) = P2V( I ) + Q2V( I ) * RN
      Q2V( I + 1 ) = Q2V( I )


	 TAUV( I + 1 ) = TAUV( I )

      RETURN
      END
