      SUBROUTINE RANGES( ENVFIL, PRTFIL, MAXNR, NR, R )

      INTEGER  ENVFIL, PRTFIL, MAXNR, NR, IR
      DIMENSION R( * )

      R( 3 ) = -999.9
      READ( ENVFIL, * ) NR, ( R( IR ), IR = 1, NR )

      IF ( NR .GT. MAXNR ) THEN
        CALL ERROUT( PRTFIL, 'F', 'RANGES', 'Too many range points')
      ENDIF

      CALL SUBTAB( R, NR )
      CALL SORT(   R, NR )

      

      DO 1000 IR = 1, NR
	  R( IR ) = 1000.0 * R( IR )
1000  CONTINUE


      IF ( R( 1 ) .LE. 0.0 ) R( 1 ) = MIN( 1.0, R( 2 ) )

200   FORMAT(2X,I2,' range''samples as the following in [m] ')
250   FORMAT (2X,6(F7.2,2X))

      RETURN
      END
      SUBROUTINE SDRD(ENVFIL,PRTFIL,ZMIN,ZMAX,MAXNSD,NSD,SD
     +                  ,MAXNRD, NRD, RD )

      INTEGER  ENVFIL, PRTFIL, MAXNSD, NSD, MAXNRD, NRD, IS, IR

      DIMENSION SD( * ), RD( * )

      NSD = 0
      SD( 3 ) = -999.9
      READ( ENVFIL, * ) NSD, ( SD( IS ), IS = 1, NSD )

      IF ( NSD .GT. MAXNSD ) THEN
        CALL ERROUT( PRTFIL, 'F', 'SDRD', ' Too many sources'  )
      ENDIF

      CALL SUBTAB( SD, NSD )
      CALL SORT( SD, NSD )

      NRD=0
      RD( 3 ) = -999.9
      READ( ENVFIL, * ) NRD, ( RD( IR ), IR = 1, NRD )
       
      IF ( NRD .GT. MAXNRD ) THEN
        CALL ERROUT( PRTFIL, 'F', 'SDRD', ' Too many receivers'  )
      ENDIF

      CALL SUBTAB( RD, NRD )
      CALL SORT( RD, NRD )

      DO 1000 IS = 1, NSD
	  IF ( SD( IS ) .LT. ZMIN ) THEN
          SD( IS ) = ZMIN
          CALL ERROUT( PRTFIL, 'W', 'SDRD',
     +    'Source in upper halfspace shifted to interface' )
	  ELSE IF ( SD( IS ) .GT. ZMAX ) THEN
          SD( IS ) = ZMAX
          CALL ERROUT( PRTFIL, 'W', 'SDRD',
     +    'Source in lower halfspace shifted to interface' )
	  ENDIF
1000  CONTINUE

      DO 2000 IR = 1, NRD
	  IF( RD( IR ) .LT. ZMIN ) THEN
          RD( IR ) = ZMIN
          CALL ERROUT( PRTFIL, 'W', 'SDRD',
     +    'Receiver in upper halfspace shifted to interface' )
	  ELSE IF ( RD( IR ) .GT. ZMAX ) THEN
          RD( IR ) = ZMAX
          CALL ERROUT( PRTFIL, 'W', 'SDRD',
     +    'Receiver in lower halfspace shifted to interface' )
	  ENDIF
2000  CONTINUE

25    FORMAT(' Receiver at ',F7.2, '  [m]')
50    FORMAT(' Source   at ',F7.2, '  [m]')
100   FORMAT(2X,6(F7.2,2X))
150   FORMAT(5X,I2,' receivers  as the following in [m] ')

      RETURN
      END

