      SUBROUTINE SUBALPHA( X, NX, CRTANGLE, DELTA_SPLITTING )


      INTEGER NX ,I, IGOOD
      DIMENSION  X(*)

	INCLUDE "BELL99.INC"
      INTEGER  DELTAXTMP, PRTFIL
      REAL MINANGLE
C
      CRTANGLE=CRTANGLE/DEGRAD      !TO DEG

      PRTFIL = 16
      MINANGLE = 0.0
      IF ( CRTANGLE .GT. 0.0 ) MINANGLE = DELTA_SPLITTING
      IF ( NX .GE. 3 .AND. X(3) .EQ. -999.9 ) THEN
	  XMIN = X(1)
	  XMAX = X(2)
        DELTAX = 10000.00 * ( X(2) - X(1) ) / ( NX - 1 )
        DELTAXTMP = DELTAX
        DELTAX = DELTAXTMP / 10000.00

        IGOOD = 1
	  DO 1000 I = 1, NX
          X(IGOOD) = XMIN + (I-1)*DELTAX
          IF ( ABS(ABS(X(IGOOD))-ABS(CRTANGLE)) .LT. MINANGLE
     +    .OR. ABS( X(IGOOD) ) .LT. .1  ) then
           IF (PRTFIL .EQ. 1) THEN
             WRITE(PRTFIL,*)
             WRITE(PRTFIL,*)' Too close to crit_angle.'
     +      ,' Dont trace ang.',X(IGOOD)
	     ENDIF
           IGOOD = IGOOD - 1
          ENDIF
          IGOOD = IGOOD + 1
1000    CONTINUE
        NX = IGOOD - 1
      ENDIF

	DO I = 1, IGOOD
        X(I)=X(I)*DEGRAD   !TO RAD
      ENDDO
  
      RETURN
      END

      SUBROUTINE SUBTAB( X, NX )

      INTEGER  PRTFIL,NX,I
      DIMENSION  X(*)
      PRTFIL = 16
      IF ( NX .GE. 3 .AND. X(3) .EQ. -999.9 ) THEN
	  XMIN = X(1)
	  XMAX = X(2)
	  DELTAX = ( X(2) - X(1) ) / ( NX - 1 )
	  DO 1000 I = 1, NX
          X(I) = XMIN + (I-1)*DELTAX
 1000   CONTINUE
      ENDIF

      RETURN
      END

      SUBROUTINE SORT( X, N )

      DIMENSION X( * )

      IF ( N .EQ. 1 ) RETURN

      DO 2000 I = 2, N

        T = X( I )

        IF ( T .LT. X( 1 ) ) THEN
          CALL SHIFTIN( X, T, 1, I - 1 )

        ELSE IF ( T .LT. X( I - 1 ) ) THEN

          IRIGHT = I - 1
          ILEFT  = 1

1000      IMID = ( ILEFT + IRIGHT ) / 2

          IF ( T .LT. X(IMID) ) THEN
            IRIGHT = IMID
          ELSE
            ILEFT  = IMID
          ENDIF

          IF ( IRIGHT .GT. ILEFT + 1 ) GOTO 1000

          CALL SHIFTIN( X, T, IRIGHT, I - 1 )

	  ENDIF

2000  CONTINUE

      RETURN
      END

      SUBROUTINE SHIFTIN( X, T, I1, I2 )


      DIMENSION X( * )

      DO 1000 K = I2, I1, -1
	  X( K + 1 ) = X( K )
1000  CONTINUE

      X( I1 ) = T

      RETURN
      END

