      SUBROUTINE TRACE( DELTAS, RS, ZS, ALPHA, OMEGA,
     &   BEAMTYP, TOPOPT, DEPTH, ZBOX, RBOX, BOTBC, NMAXB,
     +   NBB,FLAG_PERIOD,TZ,TC)

      INTEGER PRTFIL,ISTART,IEND,ICROSS,IPER
      PARAMETER ( PRTFIL = 16 )

      CHARACTER TOPOPT*3, BOTBC*1, BEAMTYP*2, BC*1

      INCLUDE 'BELL99.INC'
      COMMON /RANDEP/NPRF,INDPRF,RANGEPRF(NMAXPRF)


      DIMENSION TZ(MAXPRF),TC(MAXPRF)

      INTEGER INDPRFOLD

      BOTTOM_LAYER = 1
      HFBL_LAYER   = 1
      SURF_LAYER   = 1
      ISTART=1
      IEND=1
      ICROSS=0
      IPER=0

      INDPRF=1
      ZSNEW( 1 )=ZS
      RNALPHA( 1 )=ALPHA
      RV( 1 ) = RS
      ZV( 1 ) = ZS
      if (ibeam .eq. 69) then
	i1=0
	endif


      CALL CCUBIC( RV(1),ZV(1),C,CR,CZ,CRR,CRZ,CZZ,'TABB',TZ,TC)
      CV( 1 )    = C
	  
      RHOV(  1 ) = COS( ALPHA ) / C
      ZETAV( 1 ) = SIN( ALPHA ) / C
      
      P1V( 1 )   = 1.0
      Q1V( 1 )   = 0.0
      P2V( 1 )   = 0.0
      Q2V( 1 )   = 1.0

      TAUV( 1 )  = 0.0

      NBR=0

      NUM_REV = 0

      ZBOXT = ZBOX + 1.0e-6*ZBOX
      CRTANG(INDPRF) = 0.0
      CALL CCUBIC( RS,ZS,CZS,CR,CZ,CRR,CRZ,CZZ,'TABB',TZ,TC)
      IF( IMAXC(INDPRF) .GT. 0 .AND. ZS .LT. D_DUCTC(INDPRF)) THEN
	TTT=CZS/C_DUCTC(INDPRF)
	IF (TTT .GT. 1.0) TTT=1.0
	CRTANG(INDPRF)= ACOS(TTT)
      ENDIF

      DELTAST=DELTAS
	
      IF ((ZS .LT. D_DUCTC(INDPRF)).AND.
     &    (ABS(ALPHA) .LT. CRTANG(INDPRF))) THEN 
cM2
	DELTAST=DELTASD
      ENDIF

	IF (ALPHA .LT. 0.0 .AND. DELTAST .GT. ZSNEW(INDPRF)) 
	&	DELTAST=ZSNEW(INDPRF)-(ZSNEW(INDPRF)*.1)

C	PRINT *,DELTAST
      I = 0
      ISTEP=1
      RUNNING_DEPTH=BOTTOM(BOTTOM_LAYER)

3000  CONTINUE
      I = I + 1
c	if (ibeam .eq. 69) print *,i
      DO KKK=1,NPRF
	IF (RANGEPRF(KKK) .LE. RV(I)) INDPRF=KKK
      ENDDO

      IF (INDPRF .EQ. 1) INDPRFOLD=1
      IF (INDPRF .NE. INDPRFOLD) THEN
	ZSNEW(INDPRF)=ZV(I)
	CRTANG(INDPRF) = 0.0
	CALL CCUBIC( RV(I),ZSNEW(INDPRF),CZS,CR,CZ,CRR,CRZ,CZZ,'TABB',
     +      TZ,TC)
	IF( IMAXC(INDPRF) .GT. 0 .AND. ZSNEW(INDPRF) .LT. 
     +      D_DUCTC(INDPRF)) THEN
	  TTT=CZS/C_DUCTC(INDPRF)
	  IF (TTT .GT. 1.0) TTT=1.0
	    CRTANG(INDPRF)= ACOS(TTT)
	ENDIF

	CV( I )    = CZS
	RNALPHA(INDPRF) = ATAN2( ZV( I ) - ZV( I-1 ) ,RV( I ) - 
     +        RV( I-1 ) )


	DELTAST=DELTAS
	IF ((ZSNEW(INDPRF).LT. D_DUCTC(INDPRF)).AND.(RNALPHA(INDPRF)
     +      .LT. CRTANG(INDPRF))) THEN 
	    DELTAST=DELTASD
	ENDIF





	RHOV(  I ) = COS( RNALPHA(INDPRF) ) / CZS
	ZETAV( I ) = SIN( RNALPHA(INDPRF) ) / CZS
      ENDIF

      INDPRFOLD=INDPRF


      CHANNEL_DEPTH=D_DUCTC(INDPRF)


      CALL STEP( RV( I   ),  ZV( I   ), RHOV( I   ), ZETAV( I   ),
     +      P1V( I ), Q1V( I ),  P2V( I ),   Q2V( I ),TAUV( I ),
     +      CV( I ), RV( I+1 ),  ZV( I+1 ), RHOV( I+1 ), ZETAV( I+1 ),
     +      P1V(I+1), Q1V(I+1),  P2V(I+1),   Q2V(I+1),TAUV(I+1),
     +      DELTAST, RUNNING_DEPTH, TOPOPT, TZ,TC,
     +      CHANNEL_DEPTH,I)

      IF ( NBR .GT. 98 ) THEN
		NSTEPS = I-1
		RETURN
      ENDIF         

	IF ( RV( I ) .GT. RBOX .OR. ZV( I ) .GT. ZBOXT ) THEN
		NSTEPS = I-1
		NBCOUNT = NBCOUNT+1
		RETURN
	ENDIF

      IF ( (I .GT.5 ) .AND.  (ABS(RV(I)-RV(I-5)).LT. .1 ) ) THEN
		NSTEPS = I-1
		RETURN
      ENDIF

C      IF ((RV(I+1) .LE. RV(I))) THEN		 ! NON ACCETTA RANGE UGUALI
      IF ((RV(I+1) .LT. RV(I))) THEN		 !ACCETTA RANGE UGUALI
		NSTEPS = I-1
		RETURN
      ENDIF

	IF ( I .EQ. MAXN ) THEN
		NSTEPS = I
		RETURN
	ENDIF
	

      IF ( RV( I+1 ) .GT. BOTTOM_RANGE(BOTTOM_LAYER+1) ) then
		
          BOTTOM_LAYER = BOTTOM_LAYER + 1
c	    print *,ibeam,RV(I+1),BOTTOM_RANGE(BOTTOM_LAYER+1)
	   endif

      IF ( RV( I+1 ) .GT. HFBL_RANGE(HFBL_LAYER+1) ) then
          HFBL_LAYER = HFBL_LAYER + 1
	endif
      IF ( RV( I+1 ) .GT. WINDSPEED_RANGE(SURF_LAYER+1) )
     &     SURF_LAYER = SURF_LAYER + 1
      RUNNING_DEPTH=BOTTOM(BOTTOM_LAYER)+BOTTOM_ANGLE(BOTTOM_LAYER)*
     &   (RV( I+1 ) - BOTTOM_RANGE( BOTTOM_LAYER ))

	IF ( ZV( I + 1 ) .LE. 0.0 ) THEN
	IF ( I .GT. 1 ) THEN
	  NBR = NBR + 1
	  NUM_REV = NUM_REV +1
	  CONTREF( NBR ) = I+1
	  IF ( NBR .GT. 1 .AND.
     &        ABS(CONTREF(NBR)-CONTREF(NBR-1)) .LT. 4 
     &        .AND. CONTREF(NBR).GT.CONTREF(NBR-1) ) THEN
	      NSTEPS = I-1
	    RETURN
	  ENDIF  
     
	  GDUMMY = ( ZV( I+1 ) - ZV( I ) / RV( I+1 ) - RV( I ) )
	  REFANGLE(NBR) = ATAN2( ZV( I ) - ZV( I+1 ) ,
     &         RV( I+1 ) - RV( I ) )
	  REV_ANGLE(NUM_REV) = REFANGLE(NBR)   !/DEGRAD
	  REV_RANGE(NUM_REV) = RV(I)

	    PROVINCE(NBR) = WINDSPEED( SURF_LAYER )
	  ENDIF

	  BC(1:1) = TOPOPT(2:2)
	CALL REFLECT( 0.0, I, OMEGA, BEAMTYP, TOPOPT, BC,
     &                TZ,TC)
C
	ELSE IF ( ZV( I + 1 ) .GE. RUNNING_DEPTH ) THEN

	IF ( I .GT. 1 ) THEN
	    NBR = NBR + 1
	  NBB = NBB + 1
C ATT
	IF (NBR .GT. MAXNBR) MAXNBR=NBR
C ATT
	  NUM_REV = NUM_REV + 1
	  CONTREF( NBR ) = I+1
	  RAY_TG = (ZV( I+1 )-ZV( I )) / (RV( I+1 )-RV( I ))



	  IF ( NBR .GT. 1 .AND. ABS(CONTREF(NBR)-CONTREF(NBR-1))
     &             .LT. 4 .AND. CONTREF(NBR) .GT. CONTREF(NBR-1)
     &             .OR. NBB .GT. NMAXB ) THEN
		
	    RFONDO = RV(I) +((RUNNING_DEPTH - ZV(I))/RAY_TG)
	    RV(I+1)=RFONDO
	    ZV(I+1)=RUNNING_DEPTH
	    NSTEPS = I+1
	    RETURN
	  ENDIF         
		
	  REFANGLE(NBR) = ATAN(-BOTTOM_ANGLE(BOTTOM_LAYER)) +
     &         ATAN( RAY_TG )
	  REV_ANGLE(NUM_REV) = REFANGLE(NBR)      !/DEGRAD
	  REV_RANGE(NUM_REV) = RV(I)

	  PROVINCE(NBR) = HFBL( HFBL_LAYER )


	ENDIF

	CALL REFLECT(RUNNING_DEPTH, I, OMEGA, BEAMTYP, TOPOPT, BC,
     &                TZ,TC)

	ENDIF

      GOTO 3000        ! Next step

10000 continue      
      RETURN
      END
