      SUBROUTINE LAYER(PRTFIL,RMAX)

      INCLUDE 'BELL99.INC'

      INTEGER PRTFIL,ILAY,IR

      RAD2DEG = 1.0/DEGRAD
      ILAY = 22
      OPEN(ILAY,FILE='LAYER.ENV',FORM='FORMATTED',STATUS='UNKNOWN')

      READ(  ILAY,*) BOTTOM_LAYER

      IF(BOTTOM_LAYER .GT. 51) THEN
        CALL ERROUT( PRTFIL, 'F', 'LAYER',
     *    'Number of bottom layer points exceeds limit' )
      ENDIF


      IR = 1
      READ(  ILAY, * )  DUMX, DUMY
      BOTTOM_RANGE( IR ) = 1000.0 * DUMX
      BOTTOM( IR )       = DUMY

      DO WHILE (IR .LT. BOTTOM_LAYER)
        IR = IR + 1
        READ(  ILAY, * )  DUMX, DUMY
        BOTTOM_RANGE( IR ) = 1000.0 * DUMX
        BOTTOM( IR )       = DUMY
        BOTTOM_ANGLE( IR-1 ) = ( BOTTOM( IR ) - BOTTOM( IR-1 ) ) /
     *            ( BOTTOM_RANGE( IR ) - BOTTOM_RANGE( IR - 1 ) )
      ENDDO


      BOTTOM_ANGLE( IR ) = BOTTOM_ANGLE( IR-1 )
	BOTTOM_RANGE( IR+1 ) = 999999.99
      BOTTOM( IR+1 )       = BOTTOM( IR )
      BOTTOM_ANGLE( IR+1 ) = BOTTOM_ANGLE( IR )

	

      READ(  ILAY, * ) HFBL_LAYER

      IF(HFBL_LAYER .GT. 51) THEN
        CALL ERROUT( PRTFIL, 'F', 'LAYER',
     *    'Number of bottom table points exceeds limit' )
      ENDIF


      IR = 1
      READ( ILAY, * )  DUMX, DUMY
      HFBL_RANGE( IR ) = 1000.0 * DUMX
      HFBL( IR )       = DUMY
      DO WHILE (IR .LT. HFBL_LAYER)
        IR = IR + 1
        READ( ILAY, * )  DUMX, DUMY
        HFBL_RANGE( IR ) = 1000.0 * DUMX
        HFBL( IR )       = DUMY
      ENDDO


      HFBL_RANGE( IR+1 ) = 999999.99
      HFBL( IR+1 )       = HFBL( IR )

      READ(  ILAY,  * ) SURF_LAYER

      IF(SURF_LAYER .GT. 51) THEN
        CALL ERROUT( PRTFIL, 'F', 'LAYER',
     *    'Number of surface table points exceeds limit' )
      ENDIF


      IR = 1
      READ(  ILAY, * )  DUMX, DUMY
      WINDSPEED_RANGE( IR ) = 1000.0 * DUMX

      IF (DUMY .LT. 2) THEN
        WS=1.92+3.25*(DUMY)
      ELSE
        WS=-2.70+5.50*(DUMY)
      ENDIF

	IF (DUMY .EQ. 0) THEN
	 WS=0
	ENDIF

      WINDSPEED( IR )       = WS

      DO WHILE (IR .LT. SURF_LAYER)
        IR = IR + 1
        READ(  ILAY, * )  DUMX, DUMY
        WINDSPEED_RANGE( IR ) = 1000.0 * DUMX
        IF (DUMY .LT. 2) THEN
          WS=1.92+3.25*(DUMY)
        ELSE
          WS=-2.70+5.50*(DUMY)
        ENDIF
	  IF (DUMY .EQ. 0) THEN
	    WS=0
	  ENDIF
        WINDSPEED( IR )       = WS
      ENDDO


      WINDSPEED_RANGE( IR+1 ) = 999999.99
      WINDSPEED( IR+1 )       = WINDSPEED( IR )
      CLOSE(ILAY)

100   FORMAT( ' Bottom samples''number      = ',I2)
200   FORMAT( ' Bottom provinces''number    = ',I2)
300   FORMAT( ' Surface iso-regions''number = ',I2)
      RETURN
      END
