      SUBROUTINE SCALE( CONST, R, U, NRD, NR, RUNTYP, TOPOPT, FREQ )
      
      INTEGER PRTFIL
      
      INCLUDE 'BELL99.INC'

      REAL      R( NR )
      REAL   U( NRD, NR )
      CHARACTER TOPOPT*3, RUNTYP*2

	PRTFIL=16

      IF ( TOPOPT(3:3) .EQ. 'T' ) THEN
	  F2 = ( FREQ / 1000.0 ) ** 2
	  ALPHA = 40.0 * F2 / ( 4100.0 + F2 ) + 0.1 * F2 / ( 1.0 + F2 )
	  ALPHA = ALPHA / 914.4                 ! dB / m
	  IF (PRTFLAG .EQ . 1) THEN
	    WRITE( PRTFIL,* )
	    WRITE( PRTFIL,* ) 'Thorp Value :',
     &       ALPHA,' [dB/m]'
	  ENDIF

	  ALPHA = ALPHA / 8.6858896             ! Nepers / m

      ELSE
	  ALPHA = 0.0
      ENDIF

      DO 2000 IR = 1, NR


	  FACTOR = CONST * EXP( -ALPHA * R( IR ) ) / SQRT( R( IR ) )

        DO 1000 IRCVR = 1, NRD
	    IF ( RUNTYP(1:1) .NE. 'C' )
     &      U( IRCVR, IR ) = SQRT( U( IRCVR, IR ) )
	    U( IRCVR, IR ) = FACTOR * U( IRCVR, IR )
 1000   CONTINUE

 2000 CONTINUE

      RETURN
      END

