      SUBROUTINE STEP( R0, Z0, RHO0, ZETA0, P10, Q10, P20, Q20, TAU0,
     &             C0, R2, Z2, RHO2, ZETA2, P12, Q12, P22, Q22, TAU2,
     &             DELTAS, RUNNING_DEPTH, TOPOPT,TZ,TC,
     &             CHANNEL_DEPTH,I)
	!MS$DEBUG

  
      CHARACTER TOPOPT*3
      DIMENSION TZ(*),TC(*)
	IDUMMY = RUNNING_DEPTH

      CALL CCUBIC(R0,Z0,C0,CR0,CZ0,CRR0,CRZ0,CZZ0,'TABB',TZ,TC)

      CSQ0 = C0 * C0
      CNN0 = CSQ0 * ( CRR0 * ZETA0**2 -
     &          2.0 * CRZ0 * RHO0 * ZETA0 + CZZ0 * RHO0**2 )

      H = DELTAS

      Z = Z0 + H * C0 * ZETA0

      IF ( Z .LT. 0.0   ) 
     +    H = -1.00001 *           Z0   / ( ZETA0 * C0 )


      HH = 0.5 * H

      R1 = R0 + HH * C0 *  RHO0
      Z1 = Z0 + HH * C0 * ZETA0

      RHO1  =  RHO0 - HH * CR0 / CSQ0
      ZETA1 = ZETA0 - HH * CZ0 / CSQ0

      P11 = P10 - HH * CNN0 / CSQ0 * Q10
      Q11 = Q10 + HH * C0          * P10
      P21 = P20 - HH * CNN0 / CSQ0 * Q20
      Q21 = Q20 + HH * C0          * P20

      CALL CCUBIC(R1,Z1,C1,CR1,CZ1,CRR1,CRZ1,CZZ1,'TABB',TZ,TC)

      CSQ1 = C1 * C1
      CNN1 = CSQ1 * ( CRR1 * ZETA1**2 -
     &               2.0 * CRZ1 * RHO1 * ZETA1 + CZZ1 * RHO1**2 )

      Z = Z0 + H * C1 * ZETA1

      IF ( Z .LE. 0.0   )  
     +    H = -1.00001 *    Z0   / ( ZETA1 * C1 )


      R2 = R0 + H * C1 *  RHO1
      Z2 = Z0 + H * C1 * ZETA1


      RHO2  =  RHO0 - H * CR1 / CSQ1
      ZETA2 = ZETA0 - H * CZ1 / CSQ1

      P12 = P10 - H * CNN1 / CSQ1 * Q11
      Q12 = Q10 + H * C1          * P11
      P22 = P20 - H * CNN1 / CSQ1 * Q21
      Q22 = Q20 + H * C1          * P21


      TAU2 = TAU0 + H / C1

      RETURN
      END

