      SUBROUTINE WRTFLD( SD, RD, NRD, P, NR, IREC, R, RBOX, ZBOX,
     &      FLAG_FILTER, ZMAXTAG )


      INCLUDE 'BELL99.INC'

      REAL PLOSS(205), RR(205), PLOSSTMP(205)
      REAL R( * ),RD( * )
      REAL P( NRD, NR ), PCOM, PLOS, B_STEP

	IF (PRTFLAG .EQ. 1) THEN
        WRITE(16,*) 
        WRITE(16,*) 'LOSS PRINTED ON MAT.MAT FILE'
        WRITE(16,*) 'Numbers of Receiver Depth = ', NRD
        WRITE(16,*) 'Numebers of Ranges     = ', NR
	ENDIF
      IF(NRD.GT.1)THEN
	  OPEN(23,FILE='MAT.MAT',FORM='FORMATTED',STATUS='UNKNOWN')
      ELSE
	  OPEN(24,FILE='TLOSS.LOS',FORM='FORMATTED',STATUS='UNKNOWN')
      END IF

      B_STEP = RBOX / (NR+1)
      DO 2000 I = 1, NRD
        BOTTOM_LAYER = 1
	  IREC = IREC + 1
        DO 1000 J=1,NR
          IF ( (J-0.5)*B_STEP .GT. BOTTOM_RANGE(BOTTOM_LAYER+1) )
     &     BOTTOM_LAYER = BOTTOM_LAYER + 1
         RUNNING_DEPTH=BOTTOM(BOTTOM_LAYER)+BOTTOM_ANGLE(BOTTOM_LAYER)*
     &   ((J-0.5)*B_STEP - BOTTOM_RANGE( BOTTOM_LAYER ))
        PLOS=P(I,J)*P(I,J)
        PCOM = 200.00
        PLOSS(J)=200.
        RR(J)=(R(J)/1000.)
        IF(PLOS.GT.1.0E-20) PCOM = -10*ALOG10(PLOS)
        IF(I*ZMAXTAG/NR .GT. RUNNING_DEPTH) PCOM = 800.
        PLOSS(J)=PCOM
 1000   CONTINUE
 120    FORMAT (6(1X,E12.5))

        FLAG_FILTER = 1
	  KK=5
	  IT=KK/2
        DO II = 1, NR
		PLOSSTMP(II) = PLOSS(II)
	  ENDDO

        IF( NRD .EQ. 1 .AND. FLAG_FILTER .EQ. 1 ) THEN
            DO II = IT+1, NR-IT
 			S= 0.0
 			DO III = II-IT , II+IT
			    S = S + PLOSS(III)
			ENDDO
		    PLOSSTMP(II)=S/KK
            ENDDO
	  ENDIF

        IF(NRD.EQ.1) THEN
	    WRITE(24,120) (RR(K),K=1,NR)
          WRITE(24,120) (PLOSSTMP(K),K=1,NR)
        ELSE
	    WRITE(23,120) (PLOSS(K),K=1,NR)
        ENDIF
 2000 CONTINUE

      CLOSE(23)
      CLOSE(24)
      RETURN
      END

